Index: trunk/zoo-project/zoo-kernel/service_json.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_json.c	(revision 961)
+++ trunk/zoo-project/zoo-kernel/service_json.c	(revision 962)
@@ -1397,104 +1718,38 @@
     char *tmps12 = strtok_r (tmpMap2->value, ",", &saveptr12);
     while(tmps12!=NULL){
-      char* tmpId=(char*) malloc((strlen(tmps12)+3)*sizeof(char));
-      sprintf(tmpId,"{%s}",tmps12);
-      tmpMaps1=getMaps(conf,tmpId);
-      json_object *res8=json_object_new_object();
-      if(tmpMaps1!=NULL){
-	map* tmpMap=getMap(tmpMaps1->content,"title");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res8,"x-internal-summary",json_object_new_string(tmpMap->value));
-	tmpMap=getMap(tmpMaps1->content,"abstract");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res8,"description",json_object_new_string(tmpMap->value));
-	tmpMap=getMap(tmpMaps1->content,"example");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res8,"example",json_object_new_string(tmpMap->value));
-	tmpMap=getMap(tmpMaps1->content,"required");
-	if(tmpMap!=NULL){
-	  if(strcmp(tmpMap->value,"true")==0)
-	    json_object_object_add(res8,"required",json_object_new_boolean(TRUE));
-	  else
-	    json_object_object_add(res8,"required",json_object_new_boolean(FALSE));
-	}
-	else
-	  json_object_object_add(res8,"required",json_object_new_boolean(FALSE));
-	json_object_object_add(res8,"in",json_object_new_string("path"));
-	json_object_object_add(res8,"name",json_object_new_string(tmps12));
-	json_object *res6=json_object_new_object();
-	json_object *res7=json_object_new_object();
-	tmpMap=getMap(tmpMaps1->content,"type");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res6,"type",json_object_new_string(tmpMap->value));
-	else
-	  json_object_object_add(res6,"type",json_object_new_string("string"));
-	
-	json_object_object_add(res8,"schema",res6);
-	
-      }
-	
-      json_object_object_add(res9,tmps12,res8);
+      char* pacId=(char*) malloc((strlen(tmps12)+3)*sizeof(char));
+      sprintf(pacId,"{%s}",tmps12);
+      addParameter(conf,pacId,tmps12,"path",res9);
+      free(pacId);
       tmps12 = strtok_r (NULL, ",", &saveptr12);
     }    
     tmpMap2=getMapFromMaps(conf,"openapi","header_parameters");
-    char *saveptr13;
-    char *tmps13 = strtok_r (tmpMap2->value, ",", &saveptr13);
-    while(tmps13!=NULL){
-      char* tmpId=zStrdup(tmps13);
-      maps *tmpMaps2=getMaps(conf,tmpId);
-      json_object *res8=json_object_new_object();
-      if(tmpMaps2!=NULL){
-	map* tmpMap=getMap(tmpMaps2->content,"title");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res8,"x-internal-summary",json_object_new_string(tmpMap->value));
-	tmpMap=getMap(tmpMaps2->content,"abstract");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res8,"description",json_object_new_string(tmpMap->value));
-	tmpMap=getMap(tmpMaps2->content,"example");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res8,"example",json_object_new_string(tmpMap->value));
-	tmpMap=getMap(tmpMaps2->content,"required");
-	if(tmpMap!=NULL){
-	  if(strcmp(tmpMap->value,"true")==0)
-	    json_object_object_add(res8,"required",json_object_new_boolean(TRUE));
-	  else
-	    json_object_object_add(res8,"required",json_object_new_boolean(FALSE));
-	}
-	else
-	  json_object_object_add(res8,"required",json_object_new_boolean(FALSE));
-	json_object_object_add(res8,"in",json_object_new_string("header"));
-	tmpMap=getMap(tmpMaps2->content,"name");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res8,"name",json_object_new_string(tmpMap->value));
-	json_object *res6=json_object_new_object();
-	json_object *res7=json_object_new_object();
-	tmpMap=getMap(tmpMaps2->content,"type");
-	if(tmpMap!=NULL)
-	  json_object_object_add(res6,"type",json_object_new_string(tmpMap->value));
-	else
-	  json_object_object_add(res6,"type",json_object_new_string("string"));
-
-	{
-	  tmpMap=getMap(tmpMaps2->content,"enum");
-	  if(tmpMap!=NULL){
-	    char *saveptr11;
-	    char *tmps11 = strtok_r (tmpMap->value, ",", &saveptr11);
-	    json_object *res71=json_object_new_array();
-	    while(tmps11!=NULL){		
-	      json_object_array_add(res71,json_object_new_string(tmps11));
-	      tmps11 = strtok_r (NULL, ",", &saveptr11);
-	    }
-	    json_object_object_add(res6,"enum",res71);				  
-	  }
-	}
-	
-	json_object_object_add(res8,"schema",res6);
-	
-      }
-	
-      json_object_object_add(res9,tmpId,res8);
-      tmps13 = strtok_r (NULL, ",", &saveptr13);
-    } 
-    json_object_object_add(res,"parameters",res9);    
+    if(tmpMap2!=NULL){
+      char *saveptr13;
+      char *tmps13 = strtok_r (tmpMap2->value, ",", &saveptr13);
+      while(tmps13!=NULL){
+	char* pacId=zStrdup(tmps13);
+	addParameter(conf,pacId,pacId,"header",res9);
+	free(pacId);
+	tmps13 = strtok_r (NULL, ",", &saveptr13);
+      }
+    }
+    json_object_object_add(res,"parameters",res9);
+    maps* pmResponses=getMaps(conf,"responses");
+    if(pmResponses!=NULL){
+      json_object *cc=json_object_new_object();
+      map* pmLen=getMap(pmResponses->content,"length");
+      int iLen=atoi(pmLen->value);
+      map* pmUseContent=getMapFromMaps(conf,"openapi","use_content");
+      for(int i=0;i<iLen;i++){
+	map* cMap=getMapArray(pmResponses->content,"code",i);
+	map* vMap=getMapArray(pmResponses->content,"schema",i);
+	map* tMap=getMapArray(pmResponses->content,"type",i);
+	map* tMap0=getMapArray(pmResponses->content,"title",i);
+	if(vMap!=NULL)
+	  addResponse(pmUseContent,cc,vMap,tMap,cMap->value,(tMap0==NULL)?"successful operation":tMap0->value);
+      }
+      json_object_object_add(res,"responses",cc);
+    }
   }
 
@@ -1504,5 +1759,5 @@
     json_object_object_add(res,"components",res1);
   }
-
+  
   /**
    * Produce the JSON object for /api
@@ -1512,8 +1767,8 @@
    */
   void produceApi(maps* conf,json_object* res){
+    // TODO: add 401 Gone for dismiss request
     json_object *res9=json_object_new_object();
     json_object *res10=json_object_new_object();
     maps* tmpMaps1=getMaps(conf,"{id}");
-
     produceApiComponents(conf,res);
     json_object *res4=json_object_new_object();
@@ -1562,62 +1817,40 @@
 	    json_object *responses=json_object_new_object();
 	    json_object *cc3=json_object_new_object();
+	    map* pmUseContent=getMapFromMaps(conf,"openapi","use_content");
 	    vMap=getMapArray(tmpMaps->content,"schema",i);
 	    if(vMap!=NULL){
-	      json_object *cc=json_object_new_object();
-	      json_object_object_add(cc,"$ref",json_object_new_string(vMap->value));
-	      json_object *cc0=json_object_new_object();
-	      json_object_object_add(cc0,"schema",cc);
-	      json_object *cc1=json_object_new_object();
-	      map* tmpMap3=getMapFromMaps(conf,tmps,"type");
-	      if(tmpMap3!=NULL)
-		json_object_object_add(cc1,tmpMap3->value,cc0);
-	      else
-		json_object_object_add(cc1,"application/json",cc0);
-	      json_object *cc2=json_object_new_object();
-	      json_object_object_add(cc2,"content",cc1);
-	      json_object_object_add(cc2,"description",json_object_new_string("successful operation"));
-	      if(i==1)
-		json_object_object_add(cc3,"201",cc2);
-	      else
-		json_object_object_add(cc3,"200",cc2);
+	      map* tMap=getMapArray(tmpMaps->content,"type",i);
+	      addResponse(pmUseContent,cc3,vMap,tMap,"200","successful operation");
+	      vMap=getMapArray(tmpMaps->content,"eschema",i);
+	      if(vMap!=NULL && cMap!=NULL && strncasecmp(cMap->value,"post",4)==0)
+		addResponse(pmUseContent,cc3,vMap,tMap,"201","successful operation");
 	    }else{
-	      json_object *cc1=json_object_new_object();
-	      map* tmpMap3=getMapFromMaps(conf,tmps,"type");
-	      if(tmpMap3!=NULL)
-		json_object_object_add(cc1,tmpMap3->value,json_object_new_object());
-	      else
-		json_object_object_add(cc1,"application/json",json_object_new_object());
-	      json_object *cc2=json_object_new_object();
-	      json_object_object_add(cc2,"content",cc1);
-	      json_object_object_add(cc2,"description",json_object_new_string("successful operation"));
-	      if(i==1)
-		json_object_object_add(cc3,"201",cc2);
-	      else
-		json_object_object_add(cc3,"200",cc2);
+	      map* tMap=getMapFromMaps(conf,tmps,"type");
+	      map* pMap=createMap("ok","true");
+	      addResponse(pMap,cc3,vMap,tMap,"200","successful operation");
+	      if(cMap!=NULL && strncasecmp(cMap->value,"post",4)==0)
+		addResponse(pmUseContent,cc3,vMap,tMap,"201","successful operation");
 	    }
-	    if(strstr(tmps,"{id}")!=NULL){
-	      vMap=getMapFromMaps(conf,"exception","schema");
-	      json_object *cc=json_object_new_object();
-	      json_object_object_add(cc,"$ref",json_object_new_string(vMap->value));
-	      json_object *cc01=json_object_new_array();
-	      json_object_array_add(cc01,cc);
-
-	      json_object *cc0=json_object_new_object();
-	      json_object_object_add(cc0,"schema",cc);
-	      json_object *cc1=json_object_new_object();
-	      map* tmpMap3=getMapFromMaps(conf,"exception","type");
-	      if(tmpMap3!=NULL)
-		json_object_object_add(cc1,tmpMap3->value,cc0);
-	      else
-		json_object_object_add(cc1,"application/json",cc0);
-
-	      json_object *cc2=json_object_new_object();
-	      json_object_object_add(cc2,"content",cc1);
-	      if(strstr(tmps,"{jobID}")==NULL)
-		json_object_object_add(cc2,"description",json_object_new_string("The process with id {id} does not exist."));
-	      else
-		json_object_object_add(cc2,"description",json_object_new_string("The process with id {id} or job with id {jobID} does not exist."));
-	      json_object_object_add(cc3,"404",cc2);
-	      json_object_object_add(cc3,"default",cc2);
+	    vMap=getMapArray(tmpMaps->content,"ecode",i);
+	    if(vMap!=NULL){
+	      char *saveptr0;
+	      char *tmps1 = strtok_r (vMap->value, ",", &saveptr0);
+	      while(tmps1!=NULL){
+		char* tmpStr=(char*)malloc((strlen(tmps1)+24)*sizeof(char));
+		sprintf(tmpStr,"#/components/responses/%s",tmps1);
+		vMap=createMap("ok",tmpStr);
+		map* pMap=createMap("ok","false");
+		//TODO: fix successful operation with correct value
+		addResponse(pMap,cc3,vMap,NULL,tmps1,"successful operation");
+		tmps1 = strtok_r (NULL, ",", &saveptr0);
+	      }
+	    }else{
+	      if(strstr(tmps,"{id}")!=NULL){
+		vMap=getMapFromMaps(conf,"exception","schema");
+		map* tMap=getMapFromMaps(conf,"exception","type");
+		if(vMap!=NULL)
+		  addResponse(pmUseContent,cc3,vMap,tMap,"404",
+			      (strstr(tmps,"{jobID}")==NULL)?"The process with id {id} does not exist.":"The process with id {id} or job with id {jobID} does not exist.");
+	      }
 	    }
 	    json_object_object_add(methodc,"responses",cc3);
@@ -1640,5 +1873,5 @@
 	      json_object_object_add(methodc,"parameters",cc2);
 	    }
-	    if(i==1){
+	    if(i==1 && cMap!=NULL && strncasecmp(cMap->value,"post",4)==0){
 	      maps* tmpMaps1=getMaps(conf,"requestBody");
 	      if(tmpMaps1!=NULL){
@@ -1663,5 +1896,55 @@
 		  json_object_object_add(methodc,"requestBody",cc2);
 
+		}		
+	      }
+	      // TODO: callbacks
+	      tmpMaps1=getMaps(conf,"callbacks");
+	      if(tmpMaps1!=NULL){
+		map* pmTmp2=getMap(tmpMaps1->content,"length");
+		int iLen=atoi(pmTmp2->value);
+		json_object *pajRes=json_object_new_object();
+		for(int i=0;i<iLen;i++){
+		  map* pmState=getMapArray(tmpMaps1->content,"state",i);
+		  map* pmUri=getMapArray(tmpMaps1->content,"uri",i);
+		  map* pmSchema=getMapArray(tmpMaps1->content,"schema",i);
+		  map* pmType=getMapArray(tmpMaps1->content,"type",i);
+		  map* pmTitle=getMapArray(tmpMaps1->content,"title",i);
+		  json_object *pajSchema=json_object_new_object();
+		  if(pmSchema!=NULL)
+		    json_object_object_add(pajSchema,"$ref",json_object_new_string(pmSchema->value));
+		  json_object *pajType=json_object_new_object();
+		  json_object_object_add(pajType,"schema",pajSchema);
+		  json_object *pajContent=json_object_new_object();
+		  if(pmType!=NULL)
+		    json_object_object_add(pajContent,pmType->value,pajType);
+		  else		  
+		    json_object_object_add(pajContent,"application/json",pajType);
+		  json_object *pajRBody=json_object_new_object();
+		  json_object_object_add(pajRBody,"content",pajContent);
+		  
+		  json_object *pajDescription=json_object_new_object();
+		  if(pmTitle!=NULL)
+		    json_object_object_add(pajDescription,"description",json_object_new_string(pmTitle->value));
+		  json_object *pajResponse=json_object_new_object();
+		  json_object_object_add(pajResponse,"200",pajDescription);
+
+		  json_object *pajPost=json_object_new_object();
+		  json_object_object_add(pajPost,"requestBody",pajRBody);
+		  json_object_object_add(pajPost,"responses",pajResponse);
+
+		  json_object *pajMethod=json_object_new_object();
+		  json_object_object_add(pajMethod,"post",pajPost);
+
+		  
+		  char* pacUri=(char*) malloc((strlen(pmUri->value)+29)*sizeof(char));
+		  sprintf(pacUri,"{$request.body#/subscriber/%s}",pmUri->value);
+
+		  json_object *pajFinal=json_object_new_object();
+		  json_object_object_add(pajFinal,pacUri,pajMethod);
+
+		  json_object_object_add(pajRes,pmState->value,pajFinal);
+
 		}
+		json_object_object_add(methodc,"callbacks",pajRes);
 	      }
 	    }
Index: trunk/zoo-project/zoo-kernel/service_json.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_json.h	(revision 961)
+++ trunk/zoo-project/zoo-kernel/service_json.h	(revision 962)
@@ -2,5 +2,5 @@
  * Author : Gérald FENOY
  *
- *  Copyright 2014 GeoLabs SARL. All rights reserved.
+ *  Copyright 2014-2020 GeoLabs SARL. All rights reserved.
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
@@ -50,8 +50,13 @@
   void printGetCapabilitiesForProcessJ(registry*, maps*,void*,void*,service*);
   void printExceptionReportResponseJ(maps*,map*);
-  void parseJRequest(maps*,service* s,json_object*,maps**,maps**);
+  void parseJRequest(maps*,service* s,json_object*,map*,maps**,maps**);
   json_object*  printJResult(maps*,service*,maps*,int);
   json_object* printJobList(maps*);
   int createStatusFile(maps*,int);
+  json_object* createStatus(maps*,int);
+  char* json_getStatusFilePath(maps*);
+  json_object* parseJson(maps*,char*);
+  json_object* json_readFile(maps*,char*);
+  char* getResultPath(maps*,char*);
   int json_getStatusFile(maps*);
   void produceApi(maps*,json_object*);
Index: trunk/zoo-project/zoo-kernel/sqlapi.c
===================================================================
--- trunk/zoo-project/zoo-kernel/sqlapi.c	(revision 961)
+++ trunk/zoo-project/zoo-kernel/sqlapi.c	(revision 962)
@@ -33,4 +33,5 @@
 #include <fcgi_stdio.h>
 #include "sqlapi.h"
+#include "service_callback.h"
 
 /**
@@ -375,7 +376,11 @@
   map *msg=getMapFromMaps(conf,"lenv","message");
   map *schema=getMapFromMaps(conf,"database","schema");
-  char *sqlQuery=(char*)malloc((strlen(schema->value)+strlen(msg->value)+strlen(p->value)+strlen(sid->value)+64+1)*sizeof(char));
+  char *sqlQuery=(char*)malloc((strlen(schema->value)+strlen(msg->value)+strlen(p->value)+strlen(sid->value)+62+1)*sizeof(char));
   sprintf(sqlQuery,"UPDATE %s.services set status=$$%s$$,message=$$%s$$ where uuid=$$%s$$;",schema->value,p->value,msg->value,sid->value);
   if( zoo_DS == NULL || zoo_DS[zoo_ds_nb-1]==NULL ){
+    if(getMapFromMaps(conf,"lenv","file.log")==NULL){
+      free(sqlQuery);
+      return 1;
+    }
     init_sql(conf);
     zoo_ds_nb++;
@@ -384,4 +389,5 @@
   cleanUpResultSet(conf,zoo_ds_nb-1);
   free(sqlQuery);
+  invokeBasicCallback(conf,SERVICE_STARTED);
   return 0;
 }
@@ -398,6 +404,6 @@
   int created=-1;
   map *schema=getMapFromMaps(conf,"database","schema");
-  char *sqlQuery=(char*)malloc((strlen(schema->value)+strlen(pid)+58+1)*sizeof(char));
-  sprintf(sqlQuery,"select status||'|'||message from %s.services where uuid=$$%s$$;",schema->value,pid);
+  char *sqlQuery=(char*)malloc((strlen(schema->value)+strlen(pid)+104+1)*sizeof(char));  
+  sprintf(sqlQuery,"select CASE WHEN message is null THEN '-1' ELSE status||'|'||message END from %s.services where uuid=$$%s$$;",schema->value,pid);
   if( zoo_ds_nb==
 #ifdef META_DB
Index: trunk/zoo-project/zoo-kernel/zoo_loader.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zoo_loader.c	(revision 961)
+++ trunk/zoo-project/zoo-kernel/zoo_loader.c	(revision 962)
@@ -105,5 +105,4 @@
        int len=0;
        while((r=fread(buffer,sizeof(char),1,cgiIn))>0){
-	 fprintf(stderr,"%s",buffer);
 	 buffer[1]=0;
 	 if(res==NULL){
